package org.mai806.catalog.dao;

import org.mai806.catalog.dao.jdbc.CatalogDAO;
import org.mai806.catalog.dao.jdbc.CatalogItemDAO;
import org.mai806.catalog.dao.jdbc.AuthorDAO;
import org.mai806.catalog.dao.jdbc.Connector;

import java.sql.Connection;

/**
 *    .
 *  ,         ,
 *     DAO,    
 */
public class Session {

    public static Session getInstance() throws Exception {
        return new Session();
    }

    CatalogDAO catalogDAO;
    CatalogItemDAO catalogItemDAO;
    AuthorDAO authorDAO;

    Connection conn;

    private Session() throws Exception {
        conn = Connector.getConnection();
        conn.setAutoCommit(false);

        catalogDAO = new CatalogDAO(this);
        catalogItemDAO = new CatalogItemDAO(this);
        authorDAO = new AuthorDAO(this);
    }

    public void commit() throws Exception {
        conn.commit();
        conn.close();
    }

    public void rollback() throws Exception {
        conn.rollback();
        conn.close();
    }

    public CatalogDAO getCatalogDAO() {
        return catalogDAO;
    }

    public CatalogItemDAO getCatalogItemDAO() {
        return catalogItemDAO;
    }

    public AuthorDAO getAuthorDAO() {
        return authorDAO;
    }

    public Connection getConnection() {
        return conn;
    }
}
