package org.mai806.catalog.dao.jdbc;

import org.mai806.catalog.dao.Session;

import java.sql.*;

/**
 *   ( ) DAO -    
 */
public class BaseDAO {
    private Session session;

    public BaseDAO(Session session) {
        this.session = session;
    }

    public Session getSession() {
        return session;
    }

    protected Connection getConnection() {
        return session.getConnection();
    }

    protected long generateID() throws Exception {
        PreparedStatement stmt = null;
        ResultSet rs = null;
        try {
            stmt = getConnection().prepareStatement("select GEN_ID.nextval from DUAL");
            rs = stmt.executeQuery();
            if (rs.next()) {
                return rs.getLong(1);
            } else {
                throw new Exception("Error getting new value from sequence");
            }
        } finally {
            if (rs!=null) rs.close();
            if (stmt!=null) stmt.close();
        }
    }

    protected static void close(Statement stmt, ResultSet rs) {
        if (stmt!=null) {
            try {stmt.close();} catch (SQLException e) {e.printStackTrace();}
        }
        if (stmt!=null) {
            try {stmt.close();} catch (SQLException e) {e.printStackTrace();}
        }
    }

    protected static void close(Statement stmt) {
        close(stmt, null);
    }

}
